package hicosim.components.backend.io;

import hicosim.control.ProcessorConfig;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;

/**
 * @author Muege Oezugur, Hibetoullah Ftima
 */

public class Configurationfile {
	private BufferedReader reader; // BufferedReader erzeugen
	private BufferedWriter writer; // BufferedReader erzeugen

	private int N = 0;
	private int K = 0;
	private boolean use_debugger;
	private boolean use_scalar_mult;
	private boolean  use_vector_mult;
	private boolean use_shuffle;
	private int max_shuffle_width;
	private boolean use_vectorshift;
	private int vectorshift_width;

	//diese datei wird immer dort erstellt wo man das Prog startet
	private String path = System.getProperty("user.dir") + "/config.vhd";

	private ProcessorConfig processorConfig=null;


	public Configurationfile(ProcessorConfig config) {
		this.processorConfig = config;
	}

	public void setPATH(String PATH) {
		this.path = PATH;
	}
	//#################### HIER DIE READ METHODE ################################################################
	/**
	 *
	 * @throws - Exception
	 */
	public void read() throws Exception {
		this.reader = new BufferedReader(new InputStreamReader(
//				new FileInputStream(new File("C://config.txt"))
				new FileInputStream(new File( this.path))
				));

		String line = null;
		StringBuffer buf = new StringBuffer();
		line = this.reader.readLine();// .readLine();
		buf.append(line);
		// int a=0;
		// a= this.reader.read();
		while (line != null) { // in line wird der Inhalt der aktuellen Zeile
								// geschrieben, solange bis keine weitere Zeile
								// mehr gibt
		// System.out.print(a + ", ");
			line = this.reader.readLine();
			buf.append(line);
			// char currentSign=(char)a;
			// System.out.print(currentSign + ",");
			// a= this.reader.read();
			// line = this.reader.readLine();
		}
//		System.out.print(buf.toString());

	String s = buf.toString();
//	System.out.println("\n");
	String config[] = s.split("=");      //Splitten bis auf = gekommen und die einzelnen Zeichen in einen Array schreiben
	char[] text;
	for(int i = 1; i<config.length; i++){

		/* Leerzeichen raus */
		config[i] = config[i].replace(" ", "");


		int index = config[i].length();
		text = config[i].toCharArray();
		for(int j = 0; j<text.length; j++)
			if(text[j]==';')                    //Stelle bis zum ; erkennen in Array schreiben
		  	  /* ! index = j fuer korrekten substring */
				index = j ;
		config[i] = config[i].substring(0, index);

//		System.out.println(config[1]);

	}
//	for (int i = 1; i < config.length; i++) {
//		if(config[i] == "true")
//			System.out.println(config[i].replaceAll(" ", ""));   //Leerzeichen verwerfen
//		else if(config[i] == "false")
//			System.out.println(config[i].replaceAll(" ", ""));
//		else{
//			String.valueOf(config[i]);
//	}
//
//	}


	/* Nicht sehr flexibel, aber geht erstmal?
	 * Reihenfolge der vhd muss eingehalten werden
	 * startet bei index = 1
	 */

	N = Integer.parseInt(config[1]);

	K = Integer.parseInt(config[2]);

	use_debugger = Boolean.parseBoolean(config[3]);

	use_scalar_mult = Boolean.parseBoolean(config[4]);

	use_vector_mult = Boolean.parseBoolean(config[5]);

	use_shuffle = Boolean.parseBoolean(config[6]);

	max_shuffle_width = Integer.parseInt(config[7]);

	use_vectorshift = Boolean.parseBoolean(config[8]);

	vectorshift_width = Integer.parseInt(config[9]);

//	System.out.println("N: " + N);
//	System.out.println("K: " + K);
//	System.out.println("use_debugger: " + use_debugger);
//	System.out.println("use_scalar_mult: " + use_scalar_mult );
//	System.out.println("use_vector_mult: " + use_vector_mult );
//	System.out.println("use_shuffle: " + use_shuffle );
//	System.out.println("max_shuffle_width: " + max_shuffle_width );
//	System.out.println("use_vectorshift: " + use_vectorshift);
//	System.out.println("vectorshift_width: " + vectorshift_width);

	/**
	 * UND JETZT HIER SETUP AUFRUFEN MIT ERKANNTEN ATTRIBUTEN!!!
	 * GENAU DIESE REIHENFOLGE EINHALTEN !!!!!!!!!!
	 * GIBT DANN, WENN MANS VON HIER TESTET NULLPOPINTEREXCEPTION ABER SONST PASST DES DANN!
	 */
	this.processorConfig.setUp(N, K, use_debugger, use_scalar_mult, use_vector_mult, use_shuffle, max_shuffle_width, use_vectorshift, vectorshift_width);

}


	//#################### HIER DIE WRITE METHODE ################################################################
	/**
	 * 		void write() - Method to write to the configuration file.
	 * @param - N
	 * @param - K
	 * @param - use_debugger
	 * @param - use_scalar_mult
	 * @param - vector_mult
	 * @param - use_shuffle
	 * @param - max_shuffle_width
	 * @param - use_vectorshift
	 * @param - vectorshift_width
	 * @throws -  Exception
	 */
	public void write(int N, int K, boolean use_debugger,
			boolean use_scalar_mult,boolean use_vector_mult, boolean use_shuffle, int max_shuffle_width,
			boolean use_vectorshift, int vectorshift_width ) throws Exception{

		
		this.writer = new BufferedWriter(
	 			new FileWriter(
	 					new File( this.path )));
		

			//das oben einfach reinschreiben:
				String configuration =
							"------------------------------------------------------------------\n"+
							"-- PROJECT:     clvp (configurable lightweight vector processor)  \n" +
							"--\n"+
							"-- ENTITY:      cfg\n"+
							"-- \n"+
							"-- PURPOSE:     base configuration file\n"+
							"--	\n"+
							"-- AUTHOR:      harald manske, haraldmanske@gmx.de \n"+
							"--	\n"+
							"-- VERSION:     1.0 \n"+
							"------------------------------------------------------------------	\n"+
							"library ieee; \n"+
							"use ieee.std_logic_1164.all;\n"+
							"use ieee.numeric_std.all;\n\n"+
							"package cfg is\n"+
							"-- configuration\n";

				writer.write(configuration);
				configuration="";

				// KONFIG NEU SCHREIBEN:
				writer.write("constant n: integer := "+N+";                     -- amount of vector registers");
				writer.newLine();
				writer.write("constant k: integer := "+K+";                      -- amount words per vector register (even numbers)");
				writer.newLine();
				writer.newLine();


//				writer.write("even numbers =+ "+"--/n--"+"+*;");


				//hier jeden Parameter wie er in der Datei stehen soll
				writer.write("constant use_debugger: boolean := "+ use_debugger+"; -- include debugging unit");
				writer.newLine();
				writer.newLine();
				writer.write("constant use_scalar_mult : boolean := "+use_scalar_mult +"; -- allow multiplications in scalar alu");
				writer.newLine();
				writer.write("constant use_vector_mult : boolean := "+use_vector_mult +"; -- allow multiplications in vector alu");
				writer.newLine();
				writer.newLine();
				writer.write("constant use_shuffle : boolean := "+use_shuffle +"; -- use shuffle unit");
				writer.newLine();
				writer.write("constant max_shuffle_width : integer := "+max_shuffle_width +"; -- max. shuffle width (dividable by 4)");
				writer.newLine();
				writer.newLine();
				writer.write("constant use_vectorshift : boolean := "+use_vectorshift +";-- allow shift of vector registers (vmol, vmor)");
				writer.newLine();
				writer.write("constant vectorshift_width : integer := "+vectorshift_width +";-- width of vectorshift in bit");
				writer.newLine();

				configuration += "-- constant sram_size : integer := 4096;  -- sram size(memory size: 32 bit * sram_size)ignored in HICOSIM\n"+
						"end cfg;";

				writer.write(configuration);


				writer.flush();
				writer.close();
	}


	/**
	 * @param args
	 */
//	public static void main(String[] args) throws Exception {
//		//null: zum testen nicht wichtig, wird sonst im ProzConfig instatziert....
////		Configurationfile r = new Configurationfile(null);
//		r.read();
//
//		r.write(20, 16,  false,   true, true,   true, 16,  true, 16);
//
//	}

}



