package hicosim.components.backend.processor;


import java.util.HashSet;
import java.util.Set;

/**
 * Speicherschnittstelle
 * @author Wager, calchera,Weber
 */

public interface IMemory {
	
	public int readValueAt(int address);
	public void writeTo(int address, int value);
	
	public String loadObjectfile(String PATH)throws Exception;
	
	public Set<Integer> getAllUsedAddresses();
	
	public void resetMemory();//clear whole memory
	
	public String toString();
	
	//EDIT MICHAEL:
	public Labels getLabels();
	public String getLabelAt(int address);
	public int getAddressOfLabel(String label);
	
	public Disassembler getDisassembler();
	
	
	/* edit Andi: test fuer watchpoints */
	public void setWatchPoint(int adr);
	public void delWatchPoint(int adr);
	public boolean isWatchPoint(int adr);
	public HashSet<Integer> getAllWatchPoints();
	
	public IPluginManager getPluginManager();
	
}
