package hicosim.components.backend.processor;

import java.util.Map;
import java.util.TreeMap;

/**
 * Class to store the read in labels.
 * @author Michael Wager, 16th May 2009
 *
 */
public class Labels {
	//um fuer eine adresse das label holen:
	private Map<Integer, String> labels;
	//um fuer ein uebergebenes Label die Adresse holen:
	private Map<String, Integer> labeladdresses;
	
	public Labels() {
		this.labels=new TreeMap<Integer, String>();
		this.labeladdresses=new TreeMap<String, Integer>();
	}
	public int size() {
		return this.labels.size();
	}
	/**
	 * This method is used to put a label at the given address.
	 * It also stores the addresses.
	 * @param address
	 * @param label
	 */
	public void putLabelAt(int address, String label) {			
		this.labels.put(address, label);
		this.labeladdresses.put(label, address);
	}
	/**
	 * This method is used to get a label at the given address.
	 */ 
	public String getLabelAt(int address) {
		return this.labels.get(address);
	}
	
	 /**
	  * This method is used to get the address of a label.
	 */
	public int getAddressOfLabel(String label) {
		return this.labeladdresses.get(label);
	}
	
	/**
	 * String representation.
	 */
	public String toString() {
		return this.labels.toString();
	}
}

