package hicosim.components.backend.processor.enums;

/**
 * Enumeration of all HICOVEC Instructions.
 * 
 * @author Michael Wager, Luca Calchera, 16th May 2009
 */

public enum Instruction {
	LOAD, STORE, ADD, SUB, ADC, SBC, INC, DEC, AND, OR, XOR, MUL,
	JMP,JAL,JNC,JC,JNZ,JZ,       CLC,SEC,CLZ,SEZ,      LSL, LSR, ROL, ROR,   
	NOP, VNOP,
	MOV, MOVA,
	//VEKTORBEFEHLE:
	VLOAD, VSTORE, VMOV, VMOL, VMOR,
	
	//Vector-ALU:
	VADD, VSUB, VAND, VOR, VXOR, VMUL, VLSL, VLSR, 
	VSHUF;
}
