package hicosim.components.frontend.dialogues;

import java.awt.GridLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JComponent;
import javax.swing.JTextField;

/**
 * This class inherits a JPanel, two JLabels and two JTextFields, which are used
 * for user inputs.
 *
 * @author Daniel Obermueller & Sebastian Minning 5th June 2009
 */
public class CustomJComponent {
	private JPanel jPanel = new JPanel();
	private JTextField jTextFieldOne = new JTextField(8);
	private JTextField jTextFieldTwo = new JTextField(8);

	/**
	 *
	 * @param String titleOfFirstJLabel
	 * @param String titleOfSecondJLabel
	 */
	public CustomJComponent(String titleOfFirstJLabel,
			String titleOfSecondJLabel) {
		initialize(titleOfFirstJLabel, titleOfSecondJLabel);
	}

	/**
	 * This method returns the user generated input of the first JTextField as a
	 * String-Object.
	 *
	 * @return String
	 */
	public String getFirstInput() {
		return jTextFieldOne.getText();
	}

	/**
	 * This method returns the user generated input of the second JTextField as
	 * a String-Object.
	 *
	 * @return String
	 */
	public String getSecondInput() {
		return jTextFieldTwo.getText();
	}

	/**
	 * This method initializes this.
	 *
	 * @param String titleOfFirstJLabel
	 * @param String titleOfSecondJLabel
	 */
	private void initialize(String titleOfFirstJLabel,
			String titleOfSecondJLabel) {
		jPanel.setLayout(new GridLayout(2, 2, 5, 5));
		jPanel.add(new JLabel(titleOfFirstJLabel));
		jPanel.add(jTextFieldOne);
		jPanel.add(new JLabel(titleOfSecondJLabel));
		jPanel.add(jTextFieldTwo);
	}

	/**
	 * This method is needed in order to place this JPanel in a JOptionPane
	 * dialogue.
	 *
	 * @return JComponent
	 */
	public JComponent getComponent() {
		return jPanel;
	}
}
