/**
 *
 */
package hicosim.components.frontend;

import java.util.HashMap;

/**
 * @author Daniel Obermueller & Sebastian Minning 11th May 2009
 *
 */
public interface iListenerFrontend {

	public void displayScalarRegChanges(Object valOfA, Object valOfX, Object valOfY);

	public void displayStatusRegister(int carryBit, int zeroBit);

	public void displayInstructionPointer(int instructionPointer);

	public void setJTableVectorCpuRegisterOverviewSize(int rows, int columns);

	public void displayVectorRegChanges(int[][] vectorRegisters);

	public void displaySingleValueOfVectorRegister(Object value, int row,
			int column);

	public void displaySourceCode(String text);

	public void displayDisassembledCode(String text);

	public void displayConsoleError(String message);

	public void displayConsoleMessage(String message);

	public void displayBreakpointAtLabel(String text);

	public void displayBreakpointAtLine(String text);

	public void displayBreakpointAtAdress(String text);

	public void setBreakpointMarkAtSourceCode(int index);

	public void deleteBreakpointMarkAtSourceCode(int index);

	public void setBreakpointMarkAtDisassembledCode(int index);

	public void deleteBreakpointMarkAtDisassembledCode(int index);

	public void deleteAllBr();

	public void highlightLineOfSourceCode(int index);

	public void highlightLineOfDisassembledCode(int index);

	public void focusAtCommandline();

	public void displayCpuConfiguration(HashMap<String, String> config);

}
