/**
 *
 */
package hicosim.components.frontend.tablemodels;

import java.util.Vector;

/**
 * @author Daniel Obermueller 18th June 2009
 *
 */
public class CustomAbstractTableModelWithEditiableCells extends
		CustomAbstractTableModel {

	private static final long serialVersionUID = 1L;

	/**
	 * @param Vector
	 *            <Vector<Object>> data
	 */
	public CustomAbstractTableModelWithEditiableCells(
			Vector<Vector<Object>> data) {
		super(data);
	}

	public CustomAbstractTableModelWithEditiableCells() {
		super();
	}

	/**
	 * This method checks if the passed cell, specified by the two
	 * Integer-Objects "rowIndex" and "columnIndex", is editable. It must be
	 * overwritten in order to guarantee user inputs via mouse and keyboard.
	 *
	 * @author Daniel Obermueller 18th June 2009
	 * @param int
	 *            rowIndex
	 * @param int
	 *            columnIndex
	 * @return boolean
	 */
	public boolean isCellEditable(int rowIndex, int columnIndex) {
		/*
		 * If the row "rowIndex" and column "columnIndex" are within the bounds
		 * of the JTable and are not 0 (0 would be a column or row identifier
		 * and therefore must not be edited), the cell is editable.
		 */
		if (rowIndex > 0 && rowIndex < super.getAmountOfRows()
				&& columnIndex > 0 && columnIndex < super.getAmountOfColumns())
			return true;
		return false;
	}
}
