/**
 *  Basis-Inferace fuer Plugins
 */
package hicosim.components.plugins;


import hicosim.components.backend.processor.IPluginManager;

/**
 * @author aweber
 *
 */
public interface IPlugin {

//	public int pluginGetMemory(int adr);
//	
//	public void pluginSetMemoryAt(int adr);
//	
	
	/* Fragt Start-Adresse des Adressbereichs ab */
	public int getStartAt();
	/* Fragt End-Adresse des Adressbereichs ab */
	public int getEndAt();
	
	/* Setzt den PluginManager - wichtig fuer Speicherzugriff */
	public void setPluginManager(IPluginManager newManager);
	
	/* Plugin wird automatisch benachrichtigt, wenn sich der Wert einer Speicherzelle aendert.
	 * Beispielsweise fuer die Anzeige im GUI, es muss nicht staendig die readMemory Methode aufgerufen
	 *  werden */
	public void notifyPlugin(int address, int value);
	
	/* setzt Observerstatus des Plugins
	 * ist das Plugin Observer, wird es bei Speicherzugriffen benachrichtigt
	 * (notifyMethode des Plugins wird aufgerufen
	 */
	public void setObserver(boolean observe);
	
	/* Abfrage, ob Plugin observer ist oder nicht */
	public boolean isObserver();
	
	public void reFresh();
	
}
