package hicosim.components.plugins;

import hicosim.components.backend.processor.IPluginManager;
import javax.swing.*;

import java.awt.FlowLayout;
import java.awt.event.*;

//import javax.swing.event.*;

/*
 * Klasse soll den Drehregler des FPGAs simulieren
 *  -> Links, Center und Rechts
 *  
 *  Adresse des Drehreglers laut ScoRaceK.asm: 0xFFFF bzw. 65535
 *  
 */
public class RaceButtons implements IPlugin {

	int startAt;
	int endAt;
	
	/* Die Buttons ben�tigen keinen Lesezugriff auf den Speicher, deswegen
	 * observer = false
	 */
	boolean observe = false;
	IPluginManager pluginManager;
	
	/* Instanz von sich selbst, muss spaeter an Pluginmanager uebergeben werden */
	IPlugin instanz;
	
	
	
	
	public RaceButtons(int startAt, int endAt){
		this.startAt = startAt;
		this.endAt = endAt;
		
		this.instanz = this;
		this.render();
	}
	
	public int getEndAt() {
		return endAt;
	}

	
	public int getStartAt() {
		return startAt;
	}

	
	public boolean isObserver() {
		return this.observe;
	}

	
	public void notifyPlugin(int address, int value) {
		System.out.println("nicht implementiert");

	}

	
	public void setObserver(boolean observe) {
		this.observe = observe;

	}

	
	public void setPluginManager(IPluginManager newManager) {
		this.pluginManager = newManager;

	}
	
	public void reFresh(){
		System.err.println("Not Supported!");
	}
	
	public String toString(){
		return "Plugin fuer Buttons";
	}
	
	public void render(){
		
		JFrame f = new JFrame("Plugin fuer Buttons - TEST");
		f.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		f.setLayout(new FlowLayout());
		JButton button1 = new JButton("Links");
		JButton button2 = new JButton("Center");
		JButton button3 = new JButton("Rechts");
		
		JLabel info = new JLabel("Adresse der Buttons: " + startAt);
		
		f.add(button1);
		f.add(button2);
		f.add(button3);
		f.add(info);
		f.pack();
		f.setVisible(true);
		f.setAlwaysOnTop(true);
		
		
		/*
		 * Button Links, siehe oben und Source-Code ScotchRase!
		 */
		ActionListener a1 = new ActionListener(){
			public void actionPerformed(ActionEvent e){
				System.out.println("Links");
				try {
				pluginManager.pluginSetMemory(instanz, 65535, 16); }
				catch (Exception e1){ System.out.println("Problem beim Button Links!"); }
				 
			}
		};
		
		/* bei Druck auf Center-Button:
		 * Wert 1024 (bzw. 0x0400) wird an Adresse 65535 (fuer ScotchRace) geschrieben
		 * Grund: siehe Scotchrace-Code:
		 * LD A, 0 + 0xFFFF <- Wert von 65535 in A laden
		 * AND A, A, 0x400 <- 0x400 maskieren, 0x400 = 1024 dez
		 * SUB 0, A, 0x400 <- register A - 0x400
		 * JNZ schleife <- Wenn das Ergebnis nicht null ist -> sprung
		 * 
		 * um 0 zu erzeugen und die Schleife zu verlassen muss 65535 auf 0x400 bzw.
		 * 1024 gesetzt werden!
		 * 
		 * Button getestet, siehe Button.o!
		 */
		ActionListener a2 = new ActionListener(){
			public void actionPerformed(ActionEvent e){
				System.out.println("Center");
				try {
				/* setze Speicherzelle 65535 auf 16 */
					pluginManager.pluginSetMemory(instanz, 65535, 1024); }
				catch (Exception e1){ System.out.println("Problem beim Button Center!"); }
				 
			}
		};
		
		/* Button rechts - siehe oben und Source-Code Scotchrace! */
		ActionListener a3 = new ActionListener(){
			public void actionPerformed(ActionEvent e){
				System.out.println("Rechts");
				try {
				pluginManager.pluginSetMemory(instanz, 65535, 128); }
				catch (Exception e1){ System.out.println("Problem beim Button Links!"); }
			}
		};
		
		button1.addActionListener(a1);
		button2.addActionListener(a2);
		button3.addActionListener(a3);
		
	}
		
		
	}


