package hicosim.components.plugins.vga;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import hicosim.components.backend.processor.IPluginManager;
import hicosim.components.plugins.IPlugin;
import hicosim.control.Engine;


public class ProcessMAIN_RAM implements IPlugin {
	
	
	private Engine e;
	
	private final int startVGA = 2147403647;
	private final int endVGA = 2147403647+(80000-1);
	
	private VGAPlugin vga=null;
	
	private int color;
	
	boolean observer;
	
	private int x=0;
	private int y=0;

	public ProcessMAIN_RAM(Engine e,final VGAPlugin vga) {
		this.e = e;
		this.observer = true;
		
		this.vga=vga;
		

		// starte timer, welcher immer wieder repaint() aufruft
		new javax.swing.Timer(60, new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				vga.repaint();
			}
		}).start();
	}
	
	public int getEndAt() {
		return this.endVGA;
	}
	
	public int getStartAt() {
		return this.startVGA;
	}
	
	public boolean isObserver() {
		return this.observer;
	}
	
	public void notifyPlugin(int address, int value) {
		
		//nur fuer 16 farben, alles andere ignorieren:
		if(value>=0 && value<=15) {
			// x/y positionen auf vgaScreen berechnen:
			calculateXandY(address);
			
			//farbe holen und einen Pixe neu setzen:
			color = LookUpTable.CLUT(value);
			vga.pixels[y * vga.width() + x] = color; //.setPixelColor(x, y,  color );
		}
	}
	
	private void calculateXandY(int address) {
		int add = address-startVGA;
		int offset1 = 0;
		int offset2 = 320;
		int yOffset=0;
		//fuer jede Zeile x und y Pos. berechnen:
		for(int i=0; i<240; i++) { 
			if (add >= offset1 && add < offset2) { //wir sind in erster zeile(von insg. 240)
				y=yOffset;
				x=add-offset1;
				return;
			}
			offset1 += 320;
			offset2 += 320;
			yOffset++ ;
		}
	}
	
	
	public void reFresh() {

	}
	public void setObserver(boolean observe) {
		
	}
	public void setPluginManager(IPluginManager newManager) {
		
	}

}
