package hicosim.control.utils;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
 
/**
  * Klasse um die Ausfuehrung eines externen Prozesses in JAVA
  * mithilfe der Runtime.getRuntime().exec(<cmd>) - Methode durchzufuehren.
  * 
  * Class to exeute an external process in JAVA,
  * using the Runtime.getRuntime().exec(<cmd>) - method.
  * 
  * @author Wager
  */

public class ExecuteUtils {
 
	/**
	 * Execute an external process(e.g. clear, pwd, ls, scotchas ...)
	 */
     public String execute(String cmd) {
     	StringBuffer buf = new StringBuffer();
     	String text = null;    // Lesepuffer
     	// Stream zum Einlesen der Prozeausgabe
     	BufferedReader in;
//        PrintWriter out = new PrintWriter(System.out); //um auszugeben
     	Process p=null;
     	try {
		      // Prozess anlegen
		      p = Runtime.getRuntime().exec(cmd);
		
		      // Eingabestream holen
		      in = new BufferedReader(new  
		    		  InputStreamReader(p.getInputStream()));
		
		      // Alle Zeichen aus dem Stream auslesen und
		      // in den vector schreiben
		      
		      while ((text = in.readLine()) != null) {
		    	  buf.append(text + "\n");
//		        out.println(text);  out.flush();		
		        }
		      }
		     catch (IOException e) {
		           e.printStackTrace();
		    }
		     try {
		    	 /*
		    	  * causes the current thread to wait, 
		    	  * if necessary, until the process represented 
		    	  * by this Process object has terminated. 
		    	  * This method returns immediately if the 
		    	  * subprocess has already terminated. 
		    	  * If the subprocess has not yet terminated, 
		    	  * the calling thread will be blocked until 
		    	  * the subprocess exits.
		    	  */
		    	 p.waitFor();
		     }
		     catch (Exception e) {
				e.printStackTrace();
			}
		     
		     if(cmd.equals("clear")) {
		    	 System.out.println(buf.toString());
		    	 return "";
		     }
		     
		    int exitstatus = p.exitValue();
		    if(exitstatus != 0)//return exit message of scotchas
		    	return buf.toString();
		    else 
		    	return ""; //els return nothing
     }
     /**
      * Testing the execute method
      * @param args None
      */
//	public static void main(String[] args) {
//		//falls der ausgefuehrte Command etwas auf die Kommandozeile schreibt
//	   //wird dies abgefangen und in diesen Vector geschrieben(zB bei pwd das Verzeichnis...)
//		
//		ExecuteUtils exe = new ExecuteUtils();
//		
////		Vector<String> text = exe.execute("scotchas -o /home/froot/Desktop/ TEST_OUT.o /home/froot/Desktop/test.asm");
//		Vector<String> text = exe.execute("pwd");
//		if(text != null && text.size() != 0)
//			System.out.println(text.toString());
//		else
//			System.out.println("Everything should be ok.");
// 
//	}
 
}
 