package hicosim.control.utils;

import java.util.*;

/**
 * Interface IStatistic - used by the processor to manage statistics
 * about executed comands. IStatistic-Classes will provide methods to deal with
 * observers, to notify them on changes and to reset the observers. The observers
 * may also get the whole statistics in an arraylist.
 * 
 * @author Weber
 */

public interface IStatistic {

	public void registerObserver(IStatisticObserver newObserver);
	
	public void deleteObserver(IStatisticObserver oldObserver);
	
	public void updateStatistics(String comand);
	
	public void reset();
	
	public ArrayList<HashMap<String, Long>> getStatistics();
	
	public String[] getTypes();
	
		
}
