------------------------------------------------------------------
-- PROJECT:     Der Hicovec Prozessor in Aktion
--
-- ENTITY:      ASCII_MUL
--
-- PURPOSE:	Multiplexer VGA-RAM --> DB or ASCII
-- 
-- System to
-- Connect,
-- Operate ,
-- Transfer data and
-- Compute with the
-- Hicovec 
--
-- Prof. Gundolf Kiefer
-- Hochschule Augsburg
--
-- TEAM:
--
-- Jakob Golus
-- David Lucinkiewicz
-- Andreas Mueller
-- Florian Richter	
-- Sebastian Rigorth
-- Soeren Ruehm
--
-- 
-- DATE CREATE: 2008-12-19
-- LAST CHANGE:
-- VERSION:     0.1
-----------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.numeric_std.all;


entity ascii_mul is
	port(
		-- ASCII Eingang
		do_ascii: in std_logic;
		ascii_adr_in: in std_logic_vector (31 downto 0);
		ascii_wr: in std_logic;
		ascii_ready: out std_logic;
		-- Datebbus Eingang
		adr: in std_logic_vector (31 downto 0); 
		rd: in std_logic;
		wr: in std_logic;
		ready: out std_logic;
		-- VGARAM Ausgang
		vga_adr: out std_logic_vector (31 downto 0);
		vga_rd: out std_logic;
		vga_wr: out std_logic;
		vga_ready: in std_logic	
		);
end ascii_mul;

architecture RTL of ascii_mul is
begin
	vga_adr <= adr when do_ascii = '0' else ascii_adr_in;
	vga_wr <= wr when do_ascii = '0' else ascii_wr;
	vga_rd <= rd when do_ascii = '0' else '0';
	ready <= vga_ready when do_ascii = '0' else '0';
	ascii_ready <= vga_ready when do_ascii = '1' else '0';
	
end RTL;
