%{
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "commit.h"
#include "Parser.tab.h"

COMMENTLIST *first=NULL, *last=NULL;
int line = 1;
%}

delim		[ \t]
binaer		[01]
Ziffer		{binaer}|[2-9]
Zahl		(-?{Ziffer})*
Buchstabe	[_a-zA-Z]
String		\"(.)*\"
Register	reg[0-7]
regaxy		[AXY]
Vreg		R
Byte		B
Word		W
DoubleWord	DW
QuadWord	QW
Comment		;.*
Label 		{Buchstabe}{2}({Buchstabe}|{Ziffer})*
Merker		{Label}:
Alphavalue	'{Buchstabe}{1,2}'
HEX		0x({Ziffer}|[a-fA-F]){1,8}|$({Ziffer}|[a-fA-F]){1,8}
Perm		0b{binaer}{14}


%option yylineno
%option noyywrap
%%
\n		{line++;}
".org"		{yylval.x=line;
		 return(ORG);}
".dc"		{yylval.x=line;
		 return(DC);}
".equ"		{yylval.x=line;
		 return(EQU);}
".end"          {yylval.end.line=line;
	         yylval.end.commentl=first;
	         return(END);}
".start"        {yylval.x=line;
	         return (START);

/* ********************add new command here**************************/
/* format:
	"comand name"	{
				yylval.x=line;
				return(TOKEN of new command);
				}
 see also ADD-command below
*/


/* *********************end of new commands************************ */}

"add"		{yylval.x=line;
		 return(ADD);}
"sub"		{yylval.x=line;
		 return(SUB);}
"sal"		{yylval.x=line;
		 return(SAL);}
"sar"		{yylval.x=line;
		 return(SAR);}
"and"		{yylval.x=line;
		 return(AND);}
"or"		{yylval.x=line;
		 return(OR);}
"xor"		{yylval.x=line;
		 return(XOR);}
"not"		{yylval.x=line;
		 return(NOT);}
"ldil"		{yylval.x=line;
		 return(LDIL);}
"ldih"		{yylval.x=line;
		 return(LDIH);}
"jmp"		{yylval.x=line;
		 return(JMP);}
"halt"		{yylval.x=line;
		 return(HALT);}
"jz"		{yylval.x=line;
		 return(JZ);}
"jnz"		{yylval.x=line;
		 return(JNZ);}
"ld"		{yylval.x=line;
		 return(LD);}
"st"		{yylval.x=line;
		 return(ST);}
"adc"		{yylval.x=line;
		 return(ADC);}
"sbc"		{yylval.x=line;
		 return(SBC);}
"inc"		{yylval.x=line;
		 return(INC);}
"lsl"		{yylval.x=line;
		 return(LSL);}
"rol"		{yylval.x=line;
		 return(ROL);}
"dec"		{yylval.x=line;
		 return(DEC);}
"mul"		{yylval.x=line;
		 return(MUL);}
"lsr"		{yylval.x=line;
		 return(LSR);}
"ror"		{yylval.x=line;
		 return(ROR);}
"jal"		{yylval.x=line;
		 return(JAL);}
"jc"		{yylval.x=line;
		 return(JC);}
"jnc"		{yylval.x=line;
		 return(JNC);}
"clz"		{yylval.x=line;
		 return(CLZ);}
"sez"		{yylval.x=line;
		 return(SEZ);}
"clc"		{yylval.x=line;
		 return(CLC);}
"sec"		{yylval.x=line;
		 return(SEC);}
"nop"		{yylval.x=line;
		 return(NOP);}
"vnop"		{yylval.x=line;
		 return(VNOP);}
"mov"		{yylval.x=line;
		 return(MOV);}
"mova"		{yylval.x=line;
		 return(MOVA);}
"vld"		{yylval.x=line;
		 return(VLD);}
"vst"		{yylval.x=line;
		 return(VST);}
"vmov"		{yylval.x=line;
		 return(VMOV);}
"vmol"		{yylval.x=line;
		 return(VMOL);}
"vmor"		{yylval.x=line;
		 return(VMOR);}
"vadd"		{yylval.x=line;
		 return(VADD);}
"vsub"		{yylval.x=line;
		 return(VSUB);}
"vand"		{yylval.x=line;
		 return(VAND);}
"vor"		{yylval.x=line;
		 return(VOR);}
"vxor"		{yylval.x=line;
		 return(VXOR);}
"vmul"		{yylval.x=line;
		 return(VMUL);}	
"vlsl"		{yylval.x=line;
		 return(VLSL);}
"vlsr"		{yylval.x=line;
		 return(VLSR);}	
"vshuf"		{yylval.x=line;
		 return(VSHUF);}	
"<<"		{return(BITSHIFT_L);}
">>"		{return(BITSHIFT_R);}
"("		{return(CLAMP_OPEN);}
")"		{return(CLAMP_CLOSE);}
"^"		{return(NOTOP);}
"+"		{return(ADDOP);}
"-"		{return(SUBOP);}
"*"		{return(MULOP);}
"/"		{return(DIVOP);}
"&"		{return(ANDOP);}
"|"		{return(OROP);}
"#"		{return(RAUTE);}
"<"		{return(ECK_AUF);}
">"		{return(ECK_ZU);}


{HEX}		{
		char* endp;
		 yylval.i.line=line;		//Fehler abfangen normalerweise tritt keiner auf
		 //printf("String: %s\n" ,yytext); // for debug only
		 if (yytext[0] == '$')
			yytext[0] = '0';
		 yylval.i.value=(int)strtoul(yytext,&endp,16);
		 //printf( "Hex: %x\n", yylval.i.value); // for debug only
		 return(HEX);				//lifert das Token HEX
		}
{Zahl}		{
		yylval.i.line=line;
		yylval.i.value = atoi(yytext);	//schreibt die Zahl in die Variable yylval.zahl
		if (yylval.i.value == 0)
			return(ZERO);		//liefert das Token ZERO, wird benötigt für regaxy0 und Vektorregister (nterm Symbol in der Grammatik)
		else	
			return(ZAHL);		//liefert das Token ZAHL
		}
{String}	{
		strncpy(yylval.s.string, yytext,TEXT_LENGTH); // schreibt einen String in Anführungszeichen in die STRING-Struktur, für ASCII-Zeichen
		return(STRING);
		}
{Perm}		{
		strcpy(yylval.p.permutation, yytext); // schreibt die 14-Bit Permutationsbeschreibung in eine Puffervariable vom 				  typ char
		return(PERMUT);
		}
{regaxy}	{
		yylval.i.line=line;
		if (yytext[0]== 'A')
			yylval.i.value = 0x1;		
		else if (yytext[0]== 'X')
			yylval.i.value = 0x2;	
		else if (yytext[0]== 'Y')
			yylval.i.value = 0x3;	
		return(REGAXY);
		}
{Vreg}		{
		yylval.i.line=line;
		return(VREG);
		}

{Byte}		{
		yylval.i.line=line;
		yylval.i.value = 0;
		return(BYTE);
		}
{Word}		{
		yylval.i.line=line;
		yylval.i.value = 1;
		return(WORD);
		}
{DoubleWord}	{
		yylval.i.line=line;
		yylval.i.value = 2;
		return(DOUBLEWORD);
		}
{QuadWord}	{
		yylval.i.line=line;
		yylval.i.value = 3;
		return(QUADWORD);
		}

{Alphavalue}	{int laenge,j,help;
		 laenge=strlen(yytext)-1;
		 yylval.i.value=0;
		 for(j=1;j<laenge;j++)
		 {	
			yylval.i.value=yylval.i.value<<8;	
			yylval.i.value=yylval.i.value+yytext[j];
		 }
		 yylval.i.line=line;
		 return(ALPHAVALUE);
		}

{Register}	{yylval.i.line=line;
		 yylval.i.value=atoi(yytext+3);	//schreibt die Registernummer in yylval.i.value
		 return(REGISTER);		//und liefert das Token REGISTER an bison
		}

{Comment}	{if(first==NULL)
		 {	
		 	first=last=(COMMENTLIST*)malloc(sizeof(COMMENTLIST));
		 }
		 else
		 {
			last->next=(COMMENTLIST*)malloc(sizeof(COMMENTLIST));
			last=last->next;
		 }
		 last->line=line;
		 last->comment=(char*)malloc(strlen(yytext)*sizeof(char));
		 strcpy(last->comment,(yytext+1));
		 last->next=NULL;
		}
{Merker}	{strcpy(yylval.l.mark,yytext);
		 yylval.l.mark[strlen(yylval.l.mark)-1]='\0';
		 yylval.l.line=line;
		 return(MERKER);}
{Label}		{strcpy(yylval.l.mark,yytext);
		 yylval.l.line=line;
		 return(LABEL);}


{delim}		{/*skip*/}
","		{return(KOMMA);}
"/("		{return(CLAMP_OPEN);}
"/)"		{return(CLAMP_CLOSE);}
"["		{return(KLAMMERAUF);}
"]"		{return(KLAMMERZU);}
"."		{return(PUNKT);}
.		{return yytext[0];}	
%%
