/*! config.h
 *  In this file the constants are defined which are used often in many other functions
 *
 *  @author Eggenmueller Bernd
 *	$Revision: 1.0 $
 *	@date 25.04.2007
 */
 
//the magic number of the compiler-version
#define MAGIC_NUMBER 0xF00E
//defines if the debug mode is ON(=1) or OFF(=0)
#define DEBUG 0
// directpath to gcc
#define GCC "/usr/bin/gcc "
// options for gcc
//-x c use it as an C-sourcefile; -E only run preprocessor; -P only print adapted code in outputfile; -D name=define only accepts the define directive
#define GCC_OPTIONS "-x c -E -P -D name=define -o tmp.asm "
//the default name of the output file
#define DefaultOutFile "asm.o"
//ending of the output file
#define DESTINATION_FILE_END ".o"
//ending of the source file
#define SOURCE_FILE_END ".asm"
//the string which is written into the info-section of the output file
#define INFO "VODCA"
#define HELPTEXT "This Assembler belongs to the Scotch Project 2009 of the HS Augsburg and is adapted to the HiCoVec processor.\n\nprogramm call:\t scotchas [options]... sourcefile\n\noptions:\n-p\n--preprocessor\tswitches the preprocessor for #define-constants on\n-n\n--nosection\tminimal objectfile\n-i\n--info\t\tminimal objectfile + info section\n-c\n--comments\tminimal objectfile + comment section\n-m\n--labels\tminimal objectfile + label section\n-l\n--lines\t\tminimal objectfile + line section\n-h\n--help\tprint options\n-s\n--start\t\tignore if .start is missed\n-v\n--verbose\tverbose mode\n-o objectfilename\n--outfile objectfilename\tdefines the name of the objectfile\n"
