/*! expression.c
 *  In this file are the functions which 
 *
 *  @author Eggenmueller Bernd , Schmidt Juergen
 *	$Revision: 1.0 $
 *	@date 25.04.2007
 */
#include <string.h>
#include <stdlib.h>
#include "commit.h"

/*! This function builds a list of the whole Labels which are declared in the source file
 *
 *	@param MERKERLIST *first the first label in the label list
 *	@param char *name the name of the Label
 *	@param int adress the memory adress the Label belongs to
 *	
 *	@return MERKERLIST* pointer to the first element of the list of labels
 */
MERKERLIST* add_Merker_To_List(MERKERLIST *first, char *name, int adress)
{
	MERKERLIST *element, *help;
	element=(MERKERLIST*)malloc(sizeof(MERKERLIST));
	element->adress=adress;
	strcpy((element->name),name);
	element->length=strlen(name);	//weil im ASCII-Format 8 Bit abgespeichert und 16 benötigt werden
	element->next=NULL;	 
	if(first==NULL)
	{
		return element;
	}
	else
	{
		for(help=first;help->next!=NULL;help=help->next);
		help->next=element;
		return first;
	}
}

/*! This function add the lines and addresses they belong to to the lineArry
 *
 *	@param int actuellLine the line in which the parser is actually 
 *	@param short int *lineArray pointer to the Array in which are the whole line is the index and the value is the memory adress it belongs to
 *	@param int *lineInd the greatest line which is in the lineArray at the moment
 *	@param int aktuellAdress the adress which are write in to the lineArray at the index lineInd+1 to actuellLine
 *
 *	@return void
 */
void adressToLine(int actuellLine, short int *lineArray, int *lineInd, int aktuellAdress)
{
	for(;(*lineInd)<actuellLine;(*lineInd)++)
	{
		lineArray[(*lineInd)]=aktuellAdress;
	}	
}

/*! This function add the start adress and ending adress of an code section to the CODELIST
 *
 *	@param int startAdress is the start adress of the new code-section
 *	@param CODELIST *codelist pointer to the first code-section in th list
 *	@param int lastAdress is the ending adress of the code-section before
 *
 *	@return CODELIST* returns a pointer to the first element of the CODELIST
 */
CODELIST* addToCodelist(int startAdress,CODELIST *codelist,int lastAdress)
{
	CODELIST *dummy;
	if(codelist!=NULL)
	{
		for(dummy=codelist;dummy->next!=NULL;dummy=dummy->next);
		dummy->length=lastAdress-dummy->startAdress;
		dummy->next=(CODELIST*)malloc(sizeof(CODELIST));
		dummy=dummy->next;
		dummy->startAdress=startAdress;
		dummy->next=NULL;
	 }
	 else
	 {
		codelist=(CODELIST*)malloc(sizeof(CODELIST));
		codelist->startAdress=startAdress;
		codelist->next=NULL;
	 }
	return codelist;
}

