/*! makeObjectFile.c
 *  In this file are the functions which defines the content of the output file
 *
 *  @author Eggenmueller Bernd , Juergen Schmidt
 *	$Revision: 1.0 $
 *	@date 25.04.2007
 */
#include "functions.h"
#include "commit.h"
#include "config.h"

/*! This function creates and write the object file
 *
 *	@param MERKERLIST* firstMerker pointer to the first Merker in the Merkerlist
 *	@param int lineInd how much lines the file includes
 *	@param short int* lineTab table of the lines and memory adresses which belongs together
 *	@param COMMENTLIST* commentl pointer to the first Comment in the Commentlist
  *	@param CODELIST* firstCode pointer to the first Code in the Codelist
 *	@param short int* memory array where the code is saved
 *	@param int start the line in which start is written into the source file 
 *	@param char* datName name of output file
 *	@param int inhalt says what sections should into the output file
 *
 *	@return void
 */ 
void makeObjectDat(MERKERLIST *firstMerker, int lineInd, short int *lineTab, COMMENTLIST *commentl, CODELIST *firstCode, unsigned int *memory,int start,char *datName, int inhalt)
{
	int *secArray=NULL;
	int secAnz=0;
	int wordCounter=0;
	FILE *fp=NULL;

	secAnz=getSections(&secArray, firstMerker, lineInd, commentl, &INFO, firstCode, start, inhalt);
	if(DEBUG==1)
	{
		printSectionTab(secArray,secAnz);
	}

	fp=fopen(datName,"w");

	createHeader(&fp,MAGIC_NUMBER);
	wordCounter+=2;

	createSectionTab(&fp, &wordCounter, secArray, secAnz);

	createSections(&fp,secArray,secAnz,firstMerker,lineInd,lineTab,commentl, INFO,firstCode,memory,start);
	
	fclose(fp);
}
