/*! wertReturn.c
 *  
 *
 *  @author Eggenmueller Bernd , Juergen Schmidt
 *	$Revision: 1.0 $
 *	@date 25.04.2007
 */

#include <stdio.h>
#include "config.h"
#include "commit.h"

/*! This function creates a list of expressions and write the code into the memory Array mem
 *
 *	@param COMMAND_RETURN *command the return of the command with the new expressons and the code which should be written into the memory
 *	@param WERT_RETURN *firstExpr the list of expressions to which the new expressions should be added
 *	@param int memInd the index at which the content is at the moment
 *	@param short int *mem the array in which the memory content is saved
 *
 *	@return WERT_RETURN* returns the list with the old and new expressions
 */

/*
die Variable memInd wird übergeben bevor sie im Aufrufprogramm hochgezählt wird.
es ist nur eine lokale Kopie und wird auch nicht nach außen hin geändert.

wenn z.B. DC 1,2,3,4  somit 4 Werte gespeichert werden sollen
wird einfach die alte Adresse genommen, also memInd z.B. momentan an Adresse 7

und dann immer eines addiert und dann im jeweiligen Element diese Adresse gepeichert.
Denn der dieser Wert stellt die Adresse im Speicher da, wo das Ergebnis hingeschrieben wird.

*/
WERT_RETURN* codeAndExpr(COMMAND_RETURN *command,WERT_RETURN *firstExpr, int memInd, unsigned int *mem)
{
	WERT_RETURN *help;

	        if(command->flag==0 || command->flag==2)			// abfrage oder low8 Variablen  0 : alle anderen Befehle ohne expr.
	        {								//                              1 : assembler direktive kann auch expr. enthalten z.B. DC 80+30,
	                if(DEBUG==1) printf("%x\n",command->code);		//                              2:  Befehle mit expr.
	                mem[memInd]=command->code;
	        }								//Schreibe Code in aktulles Speicherabbildarray

	if((command->flag==1 || command->flag==2 )&& command->expr!=NULL)			// nur Befehle mit expr bearbeiten , also 1 und 2
												// bei 0 also keine Expression wird die WERT_RETURN-Liste auch nicht erweitert!!!!
	{
		if(firstExpr==NULL)								//falls noch keine expression vorhanden
		{
			firstExpr=command->expr;						// Achtung *expr ist vom Typ WERT_RETURN, kann zu
												// verwechslungen führen
			for(help=firstExpr;help!=NULL;memInd++,help=help->next)
			{
				help->memory=memInd;
			}
		}
		else										// falls schon eine Expression vorhanden wird sie einfach
												// angehängt (verkettet Liste)
		{
			for(help=firstExpr;help->next!=NULL;help=help->next);			// läuft ans Ende der verketteten Liste

			help->next=command->expr;						// Liste wird um den aktuellen ExpressionsZeiger erweitert
			for(help=help->next;help!=NULL;memInd++,help=help->next)		// Expression wird mit dem Indizes des Arrays verknüpft, also mit dem passenden Code und falls eine Liste von Expressions vorkommt kann werden mehrere angehängt
			{
				help->memory=memInd;
			}
		}
	}
	return firstExpr;
}
