/*! writeInFile.c
 *  In this file are the functions which writes into the output file
 *
 *  @author Eggenmueller Bernd , Juergen Schmidt
 *	$Revision: 1.0 $
 *	@date 25.04.2007
 */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>




/*! This function writes a string str into the output file file
 *
 *	@param FILE** file pointer to the actuell position in the output file
 *	@param char* str string which will be write into the output file
 *
 *	@return void
 */ 
void writeString(FILE **file, char *str)
{
		unsigned char zeichen;
		int i=0;
		for(i=0;i<strlen(str);i++)
		{
			zeichen=(str[i])&0xFF;
			fwrite(&zeichen,1,1,(*file));
		}
		if(strlen(str)%2!=0)
		{
			zeichen=0;
			fwrite(&zeichen,1,1,(*file));
		}
}

/*! This function writes a integer value into the output file 
 *
 *	@param int value value which will be write into the output file
 *	@param FILE** file pointer to the actuell position in the output file
 *
 *	@return void
 */
void fwriteIntBigEndian(int value,FILE **file)
{
	unsigned char high = (value>>8) & 0xFF;
	unsigned char low = value & 0xFF;
	fwrite(&high,1,1,(*file));
	fwrite(&low,1,1,(*file));
}

/*! This function writes a integer value into the output file as a 32-Bit Value
 *
 *	@param int value value which will be write into the output file
 *	@param FILE** file pointer to the actuell position in the output file
 *
 *	@return void
 */
void fwriteInt32Bit(int value,FILE **file)
{
	char buffer[4];
	char *ptr;
	int i;

	ptr = buffer;

	for (i=0; i<4; i++)
		buffer[i] = (value>>(8*i)) &0xFF;


	fwrite(ptr+2,1,2,(*file));
	fwrite(ptr,1,2,(*file));
}
