/*
*  Filename: isalive.c
*  Author: Michael Schaeferling
*  Institute: Hochschule Augsburg, Fakultaet fuer Informatik
*  Date of last change: 09-03-12
*  About: This file is part of the OnChipDebugger (via RS232).
*         This example demonstrates how to use the libraries IsAlive() function.
*  Version: 0.50
*/


#include <stdio.h>	/* printf */
#include <stdlib.h>	/* atoi */
#include <unistd.h>	/* sleep */
#include "chipdebuglib.h"

int main(int argc,char* argv[])
{
  if (argc != 2){
    printf("Usage: isalive <verbosity>\n");
    return 1;
  }
  else{
  SetVerbosity(atoi(argv[1]));
  printf("Verbosity is set to: %i\n", GetVerbosity());

  Open(IOSTREAM);
  
  /* after opening the port, we should give the target some time to send one or more alive-messages */
  sleep(1);
  
  if (IsAlive())
    printf("Alive \n");
  else
    printf("NOT alive... \n");

  Close();
  
  return 0;
  }
}

