/*
*  Filename: run_stop.c
*  Author: Michael Schaeferling
*  Institute: Hochschule Augsburg, Fakultaet fuer Informatik
*  Date of last change: 09-03-12
*  About: This file is part of the OnChipDebugger (via RS232).
*         This example demonstrates how to use the libraries Run() and Stop() functions.
*  Version: 0.50
*/


#include <stdio.h>        /* printf */
#include <stdlib.h>       /* atoi */
#include "chipdebuglib.h"

int main(int argc,char* argv[])
{
  if (argc != 3){
    printf("Usage: run_stop <chainMask> <verbosity>\n");
    return 1;
  }
  else {
  char mask = (char)atoi(argv[1]);

  SetVerbosity(atoi(argv[2]));
  printf("Verbosity is set to: %i\n", GetVerbosity());

  Open(IOSTREAM);

  if (Run(mask) != -1) {
    getchar();
    Stop();
    Close();
    return 0;
  }
  else {
    Close();
    return -1;
  }
  }
}

