/*
*  Filename: steps.c
*  Author: Michael Schaeferling
*  Institute: Hochschule Augsburg, Fakultaet fuer Informatik
*  Date of last change: 09-03-12
*  About: This file is part of the OnChipDebugger (via RS232).
*         This example demonstrates how to use the libraries Step() function.
*  Version: 0.50
*/


#include <stdio.h>        /* printf */
#include <stdlib.h>       /* atoi */
#include "chipdebuglib.h"

int main(int argc,char* argv[])
{
  if (argc != 4){
    printf("Usage: steps <chainMask> <steps> <verbosity>\n");
    return 1;
  }
  else{
  int mask = (char)atoi(argv[1]);

  SetVerbosity(atoi(argv[3]));
  printf("Verbosity is set to: %i\n", GetVerbosity());

  Open(IOSTREAM);

  if (Step(atoi(argv[2]), mask) != -1) {
    Close();
    return 0;
  }
  else {
    Close();
    return -1;
  }
  }
}

